local _G, setmetatable, rawset, require = _G, setmetatable, rawset, require
local print = print
module('nsg')

local nsgmod = {
  getopt = "getopt",
  usage = "getopt",
  getopt_ordered = "getopt",

  spy = "spy",
  
  logging = "logging",
  
  serialize = "serialize",

  xmlize = "xmlize",
  xmlInsertLast = "xmlize",
  safeXML = "xmlize",

  compareObject = "serialize",
  
  deepcopy = "deepcopy",
  
  colourstyle = "colours",
  colourstring = "colours",
  
  timer = "timer",
  
  meta = "meta",
  
  fromCSV = "csv",

   shellEnquote = "strutil",
   urlDecode = "strutil",
   urlEncode = "strutil",
   
   readpopen = "exec",
   writepopen = "exec",
   executeEx = "exec",

   getVersion = "version",

   luaToHumanUTF8 = "utf8",
   utf8index  = "utf8",
   utf8len  = "utf8",
   utf8reverse  = "utf8",
   utf8sub  = "utf8",
   utf8byteSub  = "utf8",
   utf8find  = "utf8",
   utf8split  = "utf8",

-- C modules
  test7 = "test",
  test12 = "test",
  watchdog = "watchdog",
  reboot = "reboot",
  pamAuth = "pam",
  ipsum = "ipsum",
  daemon = "daemon",
  file_exists = "fileexists",
  modem = "modem",
  modem_pair = "modem",
  hubcontrol = "hubcontrol",
  htonl = "byteorder",
  htons = "byteorder",
  ntohl = "byteorder",
  ntohs = "byteorder",
  rtlswconf = "rtlswconf",
  ip4 = "ip",
  ip6 = "ip",
  prefixToNet = "ip",
  buffer = "buffer",
  getsockoutq = "sys",
  uptime = "sys",
  crc16 = "crc",
  formatq = "formatq",
  enHex = "formatq",
}

setmetatable(_G.nsg,{
    __index = function(t,name)
      local mod = nsgmod[name]
      if mod then
        require('nsg.'..mod)
        return _G.nsg[name]
      end
    end
})

